// UnsharpMasking.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"

//vWFNg̃vpeBC/C++ˑSʁ@̒ǉ̃CN[hfBNg
// wC:\OpenCV2.2\includexǉ̂
#include "opencv2\\opencv.hpp"
 
#ifdef _DEBUG
    //Debug[h̏ꍇ
    #pragma comment(lib,"C:\\OpenCV2.2\\lib\\opencv_core220d.lib")
    #pragma comment(lib,"C:\\OpenCV2.2\\lib\\opencv_imgproc220d.lib")
    #pragma comment(lib,"C:\\OpenCV2.2\\lib\\opencv_highgui220d.lib")
#else
    //Release[h̏ꍇ
    #pragma comment(lib,"C:\\OpenCV2.2\\lib\\opencv_core220.lib")
    #pragma comment(lib,"C:\\OpenCV2.2\\lib\\opencv_imgproc220.lib")
    #pragma comment(lib,"C:\\OpenCV2.2\\lib\\opencv_highgui220.lib")
#endif

//---------------------------------------------------------------  
//y֐@zFcv_UnsharpMasking  
//yTvzFAV[v}XLO  
//y@@zFsrc        = ͉摜 
//@@@@@@Fdst        = o͉摜
//@@@@@@Fk		   = Ns̋
//y߂l@zFȂ  
//yl@@zF
//---------------------------------------------------------------   
void cv_UnsharpMasking(IplImage* src, IplImage* dst, float k){  
	//J[l̐ݒ
	float KernelData[] = {
		-k/9.0f, -k/9.0f,			-k/9.0f, 
		-k/9.0f, 1 + (8 * k)/9.0f,	-k/9.0f,
		-k/9.0f, -k/9.0f,			-k/9.0f, 
	};
	//J[l̔zCvMat֕ϊ
	CvMat kernel = cvMat (3, 3, CV_32F, KernelData);
	//tB^
	cvFilter2D (src, dst, &kernel);
}  

int _tmain(int argc, _TCHAR* argv[])
{

	//摜f[^̓Ǎ
	IplImage* src = cvLoadImage("sample.bmp", CV_LOAD_IMAGE_ANYDEPTH | CV_LOAD_IMAGE_ANYCOLOR);
	if (src == NULL){
		return 0;
	}
 
	//\EBhE̍쐬
	cvNamedWindow("src");
	cvNamedWindow("dst");
 
	//摜f[^̊m
	IplImage* dst = cvCreateImage(cvGetSize(src), src->depth, src->nChannels);
 
	//AV[v}XLO
	cv_UnsharpMasking(src, dst, 2.0f);
 
	//摜̕\
	cvShowImage ("src", src);
	cvShowImage ("dst", dst);
 
	//L[͑҂
	cvWaitKey (0);
 
	//SẴEBhE̍폜
	cvDestroyAllWindows();
 
	//摜f[^̉
	cvReleaseImage(&src);
	cvReleaseImage(&dst);

	return 0;
}


